//------------------------------------------------------------------
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_color2  DarkGray
#property indicator_color3  DarkGray
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width1  2

//
//
//
//
//

extern int    MaPeriod      = 20;
extern int    MaPrice       = PRICE_CLOSE;
extern double AtrMultiplier = 1.0;
double ema[];
double bandu[];
double bandd[];
double atravg[];
double prices[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,ema);
      SetIndexBuffer(1,bandu);
      SetIndexBuffer(2,bandd);
      SetIndexBuffer(3,atravg);
      SetIndexBuffer(4,prices);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
   for(int i = limit; i >= 0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,MaPrice,i);
         double minPeriod = MaPeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         double signal    = MathAbs(prices[i]-prices[i+MaPeriod]);
         double noise     = 0.00000000001;

               //
               //
               //
               //
               //
               
                     for(int k=0; k<MaPeriod; k++) noise += MathAbs(prices[i+k]-prices[i+k+1]);
               
               //
               //
               //
               //
               //

         double averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
         double alpha         = 2.0 / (1.0+averagePeriod);
         double atr           = iATR(NULL,0,averagePeriod,i);

         //
         //
         //
         //
         //
         
         atravg[i] = atravg[i+1]+alpha*(atr-atravg[i+1]);
         ema[i]    = ema[i+1]+alpha*(prices[i]-ema[i+1]);
         bandu[i]  = ema[i]+AtrMultiplier*atravg[i];
         bandd[i]  = ema[i]-AtrMultiplier*atravg[i];
   }      
   return(0);
}